'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _fs = require('fs');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var REGEX = /(\n?)([ \t]*)(<!--\s*#(\w+(?:-\w+)*)\s*-->)\n?([\s\S]*?)\n?(<!--\s*#end\s*-->)\n?/ig;

function regexMatchAll(string, regexp) {
  var matches = [];
  string.replace(regexp, function () {
    var arr = [].slice.call(arguments);
    matches.push(arr);
  });
  return matches;
}

var Linker = function () {
  /**
    *
    * @param config
    */

  function Linker(config) {
    _classCallCheck(this, Linker);

    this.skip = config.skip || false;
    this.entry = config.entry;
    this.output = config.output;
    this.data = config.data;
    this.hash = config.hash;
    this.hashValue = config.hashValue;
  }

  /**
    *
    * @param compiler
    */


  _createClass(Linker, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      var folder = compiler.options.context;
      var entry = (0, _path.join)(folder, this.entry);
      var output = (0, _path.join)(folder, this.output);

      compiler.plugin('compilation', function () {

        (0, _fs.readFile)(entry, 'utf8', function (err, data) {
          if (err) {
            console.error(err);
            throw err;
          }

          if (!_this.skip) {
            var matches = regexMatchAll(data, REGEX);
            matches.forEach(function (match) {
              data = data.replace(match[0], '\n' + (_this.data[match[4]] || '') + '\n');
            });
          }
          compiler.plugin('done', function (stats) {
            if (_this.hash) {
              var reg = new RegExp('\\' + _this.hash, 'g');
              var changeWith = typeof _this.hashValue === 'string' ? _this.hashValue : stats.hash;
              data = data.replace(reg, changeWith);
            }
            (0, _fs.writeFileSync)(output, data);
          });
        });
      });
    }
  }]);

  return Linker;
}();

exports.default = Linker;
module.exports = exports['default'];